Enabley API

1. Overview

Welcome to Enabley API documentation which will guide you on how to integrate an
external application by using our REST APIs. Interact with resources stored on the server by using
HTTP commands such as GET, POST, PUT, DELETE where the server receives JSON requests and returns a JSON response.

1.1. Version information

Version : 1.0.0

1.2. Contact information

Contact : Enabley
Contact Email : support@Enabley.io

2. API Pagination Description

For each endpoint above a new parameter called paginationKey was added.

The paginationKey is a unique identifier used by the application to manage pagination. During the initial endpoint call, if the number of items exceeds the maximum limit, a paginationKey is returned. This key is then used in subsequent calls to retrieve the remaining items, effectively facilitating efficient pagination.

If the provided paginationKey is invalid, a 404 Not Found status will be returned.

The API response includes a list of items, the size of each page, the current page number, the total number of pages, and a paginationKey. The paginationKey is a unique identifier used for managing pagination. If there are more pages to retrieve, the paginationKey will be provided in the response. However, if there are no more pages, the paginationKey will be null. This mechanism allows for efficient navigation through the paginated data.

3. Resources

3.1. Authorization

Authorization

3.1.1. Token

POST /api/v1/token
Description

Authorization token generation

Parameters
Type Name Description Schema

Query

clientKey
required

clientKey

string

Query

secret
required

secret

string

Responses
HTTP Code Description Schema

200

OK

TokenResponse

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.2. Catalog

Catalog operations

3.2.1. getCatalogItem

GET /api/v1/catalog/catalogItem
Parameters
Type Name Description Schema

Query

externalChannelId
required

externalChannelId

string

Query

subAccountName
optional

subAccountName

string

Responses
HTTP Code Description Schema

200

OK

ExternalCatalogItemGet

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.3. Certificates

Certificates related information

3.3.1. Get account certificates

GET /api/v1/certificates
Description

Get all certificates information for that account

Responses
HTTP Code Description Schema

200

OK

< Certificate information > array

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.3.2. Update Certificate Requirement for a User

PUT /api/v1/certificates/compliance
Description

Define whether the certificate is required for the user or not

Parameters
Type Name Description Schema

Body

requirementUpdate
required

requirementUpdate

requirementUpdate

Responses
HTTP Code Description Schema

200

Requirement status was updated

OkResponse

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

404

User or certificate not found

ErrorResponse

409

No existing user-certificate connection

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.3.3. Get user’s certificates

GET /api/v1/certificates/users/{externalUserId}
Description

Get all of the user’s accomplishments in form of certificates

Parameters
Type Name Description Schema

Path

externalUserId
required

externalUserId

string

Responses
HTTP Code Description Schema

200

OK

< ExternalUserCertificateState > array

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.3.4. Get account certificates V2

GET /api/v2/certificates
Description

Get all certificates information for that account

Parameters
Type Name Description Schema

Query

paginationKey
optional

Pagination key

string

Responses
HTTP Code Description Schema

200

OK

PaginationResponse«Certificate information»

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.3.5. Get account certificate by external certificate id

GET /api/v2/certificates/{externalCertificateId}
Description

Get certificate by external certificate id

Parameters
Type Name Description Schema

Path

externalCertificateId
required

External certificate id

string

Responses
HTTP Code Description Schema

200

OK

Certificate information

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.4. Channels

Operations on Channels

3.4.1. Get account channels

GET /api/v1/channels
Description

Get all channels that a certain account contains

Parameters
Type Name Description Schema

Query

createdSince
optional

Filter by channels created since the specified date (format: YYYY-MM-DDTHH:mm:ss.SSSZ)

string

Query

includeCategories
optional

Channel categories

boolean

Query

subAccountName
optional

Sub-account name

string

Responses
HTTP Code Description Schema

200

OK

< ChannelInfo > array

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.4.2. Create or update Channel

PUT /api/v1/channels
Description

Operations that creates or update channel

Parameters
Type Name Description Schema

Body

channelUpdate
required

Channel data

ChannelData

Responses
HTTP Code Description Schema

200

Channel was updated

OkResponse

201

Channel was created

OkResponse

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.4.3. Get Course Training Events

GET /api/v1/channels/{channelIdentifier}/courses/events
Description

Get all Course Training Events

Parameters
Type Name Description Schema

Path

channelIdentifier
required

Channel identifier

string

Responses
HTTP Code Description Schema

200

OK

< TrainingEvent > array

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.4.4. Assign group to channel

POST /api/v1/channels/{channelIdentifier}/groups/{groupIdentifier}
Description

Assign group to channel

Parameters
Type Name Description Schema Default

Path

channelIdentifier
required

Channel identifier

string

Path

groupIdentifier
required

Group identifier

string

Query

recursive
optional

recursive

boolean

"true"

Query

userRole
optional

Channel member type

enum (LEARNER)

"LEARNER"

Responses
HTTP Code Description Schema

200

OK

OkResponse

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.4.5. Remove group from channel

DELETE /api/v1/channels/{channelIdentifier}/groups/{groupIdentifier}
Description

Remove group from channel

Parameters
Type Name Description Schema

Path

channelIdentifier
required

Channel identifier

string

Path

groupIdentifier
required

Group identifier

string

Responses
HTTP Code Description Schema

200

OK

OkResponse

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.4.6. Remove user from channel

DELETE /api/v1/channels/{channelIdentifier}/users/{userIdentifier}
Description

Remove user from channel

Parameters
Type Name Description Schema

Path

channelIdentifier
required

Channel identifier

string

Path

userIdentifier
required

User identifier

string

Responses
HTTP Code Description Schema

200

OK

OkResponse

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.4.7. Find channel by identifier

GET /api/v1/channels/{identifier}
Description

Find channel by identifier

Parameters
Type Name Description Schema

Path

identifier
required

Channel identifier

string

Query

includeCategories
optional

Channel categories

boolean

Responses
HTTP Code Description Schema

200

OK

ChannelInfo

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.4.8. Get account master channels

GET /api/v2/channels/channels/masters
Description

Get all master channels within an account

Parameters
Type Name Description Schema

Query

onlyPublished
optional

Only include published master channels

boolean

Query

subAccountName
optional

Sub-account name

string

Responses
HTTP Code Description Schema

200

OK

< ExternalMasterChannelGet > array

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.4.9. Retrieve the number of members in a channel

GET /api/v2/channels/channels/{channelIdentifier}/members/count
Description

Retrieve the number of members in a channel

Parameters
Type Name Description Schema

Path

channelIdentifier
required

Channel identifier

string

Responses
HTTP Code Description Schema

200

OK

ExternalChannelMembersInfoGet

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.4.10. Create a channel instance from a master course

PUT /api/v2/channels/master/instance
Description

Operation that creates a channel instance from a master course

Parameters
Type Name Description Schema

Body

channelUpdate
required

Channel instance creation data

ExternalChannelInstance

Responses
HTTP Code Description Schema

200

OK

OkResponse

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.4.11. Assign user to channel

POST /api/v2/channels/{channelIdentifier}/users/{userIdentifier}
Description

Assign user to channel

Parameters
Type Name Description Schema

Path

channelIdentifier
required

Channel identifier

string

Path

userIdentifier
required

User identifier

string

Query

roles
required

Assign a user a role, Learner or Instructor, note that an instructor is assigned with basic course permissions

< enum (LEARNER, INSTRUCTOR) > array(multi)

Responses
HTTP Code Description Schema

200

OK

OkResponse

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.4.12. Get account channels V3

GET /api/v3/channels
Description

Get all channels that a certain account contains

Parameters
Type Name Description Schema

Query

includeCategories
optional

Channel categories

boolean

Query

paginationKey
optional

Pagination key

string

Query

subAccountName
optional

Sub-account name

string

Responses
HTTP Code Description Schema

200

OK

PaginationResponse«ChannelInfo»

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.4.13. Get account master channels V3

GET /api/v3/channels/masters
Description

Get all master channels within an account

Parameters
Type Name Description Schema

Query

onlyPublished
optional

Only include published master channels

boolean

Query

paginationKey
optional

Pagination key

string

Query

subAccountName
optional

Sub-account name

string

Responses
HTTP Code Description Schema

200

OK

PaginationResponse«ExternalMasterChannelGet»

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.4.14. Force complete a channel for a learner

POST /api/v4/channels/forceComplete/channel/{channelIdentifier}/user/{userIdentifier}
Description

Mark all non-optional content items and training events in the channel as completed for the specified learner.

Parameters
Type Name Description Schema

Path

channelIdentifier
required

User identifier

string

Path

userIdentifier
required

Channel identifier

string

Responses
HTTP Code Description Schema

200

OK

OkResponse

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.5. Groups

Operations on Groups

3.5.1. Create or update Group

PUT /api/v1/groups
Description

Operations that creates or update Group

Parameters
Type Name Description Schema

Body

groupUpdate
required

Group data

GroupData

Responses
HTTP Code Description Schema

200

Group was updated

OkResponse

201

Group was created

OkResponse

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.5.2. Get hierarchy

GET /api/v1/groups/hierarchy
Description

Get account’s group hierarchy

Responses
HTTP Code Description Schema

200

OK

< string > array

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.5.3. Get Groups

GET /api/v1/groups/list
Description

Get groups by account or sub-account name

Parameters
Type Name Description Schema

Query

subAccountName
optional

Sub-account name

string

Responses
HTTP Code Description Schema

200

OK

< GroupInfo > array

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.5.4. Assign User to Group

POST /api/v1/groups/{groupIdentifier}/users/{userIdentifier}
Description

Assign User to Group

Parameters
Type Name Description Schema

Path

groupIdentifier
required

Group identifier

string

Path

userIdentifier
required

User identifier

string

Query

replace
optional

Remove all current mapping of user to groups

boolean

Responses
HTTP Code Description Schema

200

OK

OkResponse

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.5.5. Remove User from Group

DELETE /api/v1/groups/{groupIdentifier}/users/{userIdentifier}
Description

Assign User to Group

Parameters
Type Name Description Schema

Path

groupIdentifier
required

Group identifier

string

Path

userIdentifier
required

User identifier

string

Responses
HTTP Code Description Schema

200

OK

OkResponse

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.5.6. Find group

GET /api/v1/groups/{identifier}
Description

Find group by identifier

Parameters
Type Name Description Schema

Path

identifier
required

Group identifier

string

Query

subAccountName
optional

Sub-account name

string

Responses
HTTP Code Description Schema

200

OK

GroupInfo

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.5.7. deleteGroup

DELETE /api/v1/groups/{identifier}
Parameters
Type Name Description Schema

Path

identifier
required

Group identifier

string

Responses
HTTP Code Description Schema

200

OK

OkResponse

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.5.8. Find user group(s) by user identifier

GET /api/v1/users/{identifier}/groups
Description

Find user group(s) by user identifier

Parameters
Type Name Description Schema

Path

identifier
required

User identifier

string

Query

subAccountName
optional

Sub-account name

string

Responses
HTTP Code Description Schema

200

OK

< GroupInfo > array

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.6. Performance

User related performance

3.6.1. Get users channel performance

GET /api/v1/performance
Description

Get the user’s overall performance for a specified channel. If no externalChannelId is provided, the performance for all channels of that user will be returned.
In addition, users with no ExternalId set will not be included.
If externalChannelId is provided, the performance of the user in the given channel will be returned.

Parameters
Type Name Description Schema

Query

externalChannelId
optional

externalChannelId

string

Query

externalUserId
optional

externalUserId

string

Responses
HTTP Code Description Schema

200

OK

< External user channel performance > array

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.6.2. Get performance by user, channel, or both

GET /api/v2/performance
Description

Retrieve learner performance for a specific channel, or a specific user, or both.

Parameters
Type Name Description Schema

Query

channelIdentifier
optional

Channel identifier

string

Query

paginationKey
optional

Pagination key

string

Query

userIdentifier
optional

User identifier

string

Responses
HTTP Code Description Schema

200

OK

PaginationResponse«External user channel performance»

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.7. Uploads

Uploads operations

3.8. UserProfiles

Operations on UserProfiles

3.8.1. Get profile details by id(s)

POST /api/v2/getUserProfiles
Description

Get profile details by id(s)

Parameters
Type Name Description Schema

Body

identifiers
required

User Profile data

< string > array

Responses
HTTP Code Description Schema

200

OK

< UserProfileInfo > array

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.8.2. Create or update User Profile

PUT /api/v2/userProfiles
Description

Operations that create or update user profile

Parameters
Type Name Description Schema

Body

externalUserProfileUpdate
required

User Profile data

UserProfileData

Responses
HTTP Code Description Schema

200

User Profile was updated

OkResponse

201

User Profile was created

OkResponse

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.8.3. Find profiles of a user by user identifier

POST /api/v2/userProfiles/users/{identifier}
Description

Find profiles of a user by user identifier

Parameters
Type Name Description Schema

Path

identifier
required

User identifier

string

Responses
HTTP Code Description Schema

200

OK

< UserProfileInfo > array

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.8.4. Assign profile of a user by user identifier and profile identifier

PUT /api/v2/userProfiles/{profileIdentifier}/users/{userIdentifier}
Description

Assign profile of a user by user identifier and profile identifier

Parameters
Type Name Description Schema

Path

profileIdentifier
required

Profile identifier

string

Path

userIdentifier
required

User identifier

string

Query

replace
optional

Remove all current mapping of user to profiles

boolean

Responses
HTTP Code Description Schema

200

Assignment of profile of a user was updated

OkResponse

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.8.5. Remove profile of a user by user identifier and profile identifier

DELETE /api/v2/userProfiles/{profileIdentifier}/users/{userIdentifier}
Description

Remove profile of a user by user identifier and profile identifier

Parameters
Type Name Description Schema

Path

profileIdentifier
required

Profile identifier

string

Path

userIdentifier
required

User identifier

string

Responses
HTTP Code Description Schema

200

Remove assignment of profile of a user was updated

OkResponse

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.9. Users

Operations on Users

3.9.1. Find users by filter

GET /api/v2/users
Description

Find users by filter

Parameters
Type Name Description Schema

Query

emailSubstring
optional

Email substring

string

Query

firstNameSubstring
optional

First name substring

string

Query

identifier
optional

The unique id of user

string

Query

lastNameSubstring
optional

Last name substring

string

Query

limit
optional

Page size. Max:200 items

integer(int32)

Query

start
optional

Start index

integer(int32)

Query

subAccountName
optional

Sub-Account name of the user

string

Query

usernameSubstring
optional

Email substring

string

Responses
HTTP Code Description Schema

200

OK

< UserInfo > array

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.9.2. Create or update User

PUT /api/v2/users
Description

Create new user or update an existing user based on consumer identifier

Parameters
Type Name Description Schema

Body

userUpdate
required

User data

UserData

Responses
HTTP Code Description Schema

200

User was updated

OkResponse

201

User was created

OkResponse

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.9.3. Add user entity role

POST /api/v2/users/entitlements
Description

Add user entity role to Course, Group, Workspace

Parameters
Type Name Description Schema

Body

entitlement
required

entitlement

ExternalEntitlement

Responses
HTTP Code Description Schema

200

OK

OkResponse

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.9.4. Remove user entity role

DELETE /api/v2/users/entitlements
Description

Remove user entity role from Course, Group, Workspace

Parameters
Type Name Description Schema

Body

entitlement
required

entitlement

ExternalEntitlement

Responses
HTTP Code Description Schema

200

OK

OkResponse

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.9.5. Change the user identifier (user ID) for an existing user.

PUT /api/v2/users/identityManagement
Parameters
Type Name Description Schema

Body

userIdentity
required

userIdentity

UserIdentity

Responses
HTTP Code Description Schema

200

OK

OkResponse

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.9.6. Find user by identifier

GET /api/v2/users/{identifier}
Description

Find user by identifier

Parameters
Type Name Description Schema

Path

identifier
required

User identifier

string

Query

subAccountName
optional

Sub-account name

string

Responses
HTTP Code Description Schema

200

OK

UserInfo

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.9.7. Update existing user status

PUT /api/v2/users/{identifier}
Description

Update existing user status

Parameters
Type Name Description Schema

Path

identifier
required

User identifier

string

Query

isActive
required

User status. Possible values: "true" or "false". Default: true

boolean

Responses
HTTP Code Description Schema

200

OK

OkResponse

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.9.8. Delete user by identifier

DELETE /api/v2/users/{identifier}
Description

Delete user by identifier

Parameters
Type Name Description Schema

Path

identifier
required

User identifier

string

Responses
HTTP Code Description Schema

200

OK

OkResponse

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.9.9. Remove a user from a particular sub-account

DELETE /api/v2/users/{identifier}/subAccountName/{subAccountName}
Description

Removes a user from a particular sub-account

Parameters
Type Name Description Schema

Path

identifier
required

User identifier

string

Path

subAccountName
required

Sub-account name

string

Responses
HTTP Code Description Schema

200

OK

OkResponse

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.9.10. Set user permissions

PUT /api/v2/users/{userIdentifier}/permissions
Description

Set user permissions for a user. The user role must be INSTRUCTOR. The permissions list will override any existing permissions the user might have.

Parameters
Type Name Description Schema

Path

userIdentifier
required

userIdentifier

string

Body

permissions
required

permissions

ExternalPermission

Responses
HTTP Code Description Schema

200

OK

OkResponse

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

3.9.11. Find users by filter V3 New

GET /api/v3/users
Description

Find users by filter

Parameters
Type Name Description Schema

Query

emailSubstring
optional

Email substring

string

Query

firstNameSubstring
optional

First name substring

string

Query

identifier
optional

The unique id of user

string

Query

lastNameSubstring
optional

Last name substring

string

Query

paginationKey
optional

Pagination key

string

Query

subAccountName
optional

Sub-Account name of the user

string

Query

usernameSubstring
optional

Email substring

string

Responses
HTTP Code Description Schema

200

OK

PaginationResponse«UserInfo»

400

Invalid input

ErrorResponse

401

Invalid JWT token

ErrorResponse

500

General error

ErrorResponse

Consumes
  • application/json

Produces
  • application/json

4. Definitions

4.1. Certificate information

Name Description Schema

courseIds
optional

Courses related to the certificate

< string > array

created
optional

Certificate creation date

YYYY-MM-DDTHH:mm:ss.SSSZ

expiration
optional

Certificate expiration

CertificateExpiration

externalCertificateId
optional

External Certificate Id

string

name
optional

Certificate name

string

status
optional

Certificate status

enum (ACTIVE, INACTIVE, ARCHIVED)

4.2. CertificateExpiration

Name Schema

duration
optional

integer(int32)

period
optional

enum (MONTH, YEAR, DAY)

4.3. ChannelAvailability

Name Description Schema

schedule
optional

Channel Schedule

Schedule

status
required

Channel Status

enum (ACTIVE, NONACTIVE, DRAFT, SCHEDULED, STARTED, FINISHED)

4.4. ChannelData

Channel data for update

Name Description Schema

identifier
required

The unique id of the model entity - defined by an external provider

string

name
required

Channel name

string

status
optional

Channel Status ACTIVE/INACTIVE

enum (ACTIVE, INACTIVE)

subAccountName
optional

The sub-account to which the channel belongs

string

type
required

Channel Type STREAM/COURSE

enum (STREAM, COURSE)

4.5. ChannelInfo

Channel info

Name Description Schema

availability
required

Channel Availability

ChannelAvailability

categories
optional

Channel category names

< string > array

created
required

Channel creation date

YYYY-MM-DDTHH:mm:ss.SSSZ

directLink
optional

Channel direct link

string

duration
optional

Channel duration

integer(int64)

identifier
required

The unique id of the model entity - defined by an external provider

string

masterChannelId
optional

The unique channel id of the master channel as defined by an external provider, or null if this channel is not a master channel instance

string

masterChannelInstance
required

Is this channel an instance of a master channel
Example : false

boolean

name
required

Channel name

string

subAccountName
required

The name of the Sub-Account for this Channel

string

type
required

Channel Type STREAM/COURSE

enum (STREAM, COURSE)

4.6. ErrorResponse

ErrorResponse

Name Description Schema

error
required

The error may have one of the following values:

enum (invalid_request, invalid_client, not_found, access_denied, general_error, item_exists, item_not_exists, service_unavailable)

error_description
required

Error description

string

4.7. External user channel performance

Name Description Schema

channelName
optional

Channel name

string

completionDate
optional

Completion date

YYYY-MM-DDTHH:mm:ss.SSSZ

externalChannelId
optional

External channel id

string

externalUserId
optional

External user id

string

progress
optional

Channel progress

integer(int32)

score
optional

Total score

integer(int32)

4.8. ExternalCatalogItemGet

Name Schema

catalogItemId
optional

string

link
optional

string

4.9. ExternalChannelInstance

Name Description Schema

identifier
required

The unique id of the model entity - defined by an external provider

string

masterCourseIdentifier
optional

The unique id of the master course - defined by an external provider

string

name
required

Channel name

string

subAccountName
optional

The sub-account to which the channel belongs

string

4.10. ExternalChannelMembersInfoGet

Name Description Schema

learners
required

The number of learners in the channel, 0 if none

integer(int32)

4.11. ExternalEntitlement

Name Schema

entityIdentifier
optional

string

entityType
optional

enum (COURSE, GROUP, WORKSPACE)

userIdentifier
required

string

userRole
required

enum (MANAGER, EDITOR, INSTRUCTOR)

4.12. ExternalMasterChannelGet

Name Description Schema

categories
optional

Channel category names

< string > array

created
optional

The master channel creation date

YYYY-MM-DDTHH:mm:ss.SSSZ

identifier
required

The unique id of the model entity - defined by an external provider

string

name
required

The master channel name

string

published
optional

Only include published master channels
Example : false

boolean

subAccountName
optional

The sub-account to which the master channel belongs

string

4.13. ExternalOrgBulkUploadRequest

Name Schema

files
required

< OrgBulkDataRequest > array

4.15. ExternalPermission

Name Schema

permissions
required

< enum (INSTRUCTOR_CREATE_COURSE_INSTANCE, INSTRUCTOR_CREATE_COURSE) > array

4.16. ExternalUserCertificateState

Name Description Schema

certificationDate
optional

The date in which the user was certified

YYYY-MM-DDTHH:mm:ss.SSSZ

expirationDate
optional

The date the user’s certification will no longer be valid

YYYY-MM-DDTHH:mm:ss.SSSZ

externalCertificateId
optional

External Certificate Id

string

isRequired
optional

isRequired
Example : false

boolean

name
optional

Certificate name

string

pdfUrl
optional

Certificate PDF

string

state
optional

Certificate state

enum (IN_PROGRESS, CERTIFIED, AWAITS_LEARNER_CONFIRMATION, ABOUT_TO_EXPIRE, EXPIRED, INIT, REVOKED)

4.17. GroupData

Group data for update

Name Description Schema

identifier
required

The unique id of the model entity - defined by an external provider

string

name
required

Group name

string

parentIdentifier
optional

parent identifier, defined by an external provider. The group with parentIdentifier must exist

string

subAccountName
optional

Sub-account name

string

type
required

Group type according to group hierarchy

string

4.18. GroupInfo

Group info

Name Description Schema

created
required

Group creation date

YYYY-MM-DDTHH:mm:ss.SSSZ

identifier
required

The unique id of the model entity - defined by an external provider

string

modified
required

Group modification date. i.e 2017-12-13T13:14:28.317Z

YYYY-MM-DDTHH:mm:ss.SSSZ

name
required

Group name

string

parentIdentifier
required

parent identifier, defined by an external provider

string

subAccountName
required

Sub-Account to which the group belongs

string

type
required

Group type according to group hierarchy

string

4.19. OkResponse

OkResponse

Name Description Schema

message
required

Message description

string

4.20. OrgBulkDataRequest

Name Description Schema

content
required

content

string

fileName
required

fileName

string

4.21. PaginationResponse«Certificate information»

Name Schema

currentPage
optional

integer(int32)

items
optional

< Certificate information > array

pageSize
optional

integer(int32)

paginationKey
optional

string

totalPages
optional

integer(int64)

4.22. PaginationResponse«ChannelInfo»

Name Schema

currentPage
optional

integer(int32)

items
optional

< ChannelInfo > array

pageSize
optional

integer(int32)

paginationKey
optional

string

totalPages
optional

integer(int64)

4.23. PaginationResponse«External user channel performance»

Name Schema

currentPage
optional

integer(int32)

items
optional

< External user channel performance > array

pageSize
optional

integer(int32)

paginationKey
optional

string

totalPages
optional

integer(int64)

4.24. PaginationResponse«ExternalMasterChannelGet»

Name Schema

currentPage
optional

integer(int32)

items
optional

< ExternalMasterChannelGet > array

pageSize
optional

integer(int32)

paginationKey
optional

string

totalPages
optional

integer(int64)

4.25. PaginationResponse«UserInfo»

Name Schema

currentPage
optional

integer(int32)

items
optional

< UserInfo > array

pageSize
optional

integer(int32)

paginationKey
optional

string

totalPages
optional

integer(int64)

4.26. Schedule

Name Description Schema

endDate
optional

Channel End Date

string

startDate
optional

Channel Start Date

string

4.27. TokenResponse

TokenResponse

Name Description Schema

access_token
required

Access token that should be used in API calls

string

expires_in
required

expiration time in ms

integer(int32)

token_type
required

token type; always bearer

string

4.28. TrainingEvent

Training Event

Name Description Schema

allDayEvent
optional

Indicates if the training event lasts the entire day
Example : false

boolean

description
optional

Training event description

string

fromDate
optional

Start date and time of the training event

YYYY-MM-DDTHH:mm:ss.SSSZ

includeGrade
optional

Indicates if grading is included for the training event
Example : false

boolean

isPublished
optional

Indicates if the training event is published
Example : false

boolean

liveSession
optional

Indicates if the training event is a live session
Example : false

boolean

location
optional

Event location

string

name
optional

The name of the training event

string

untilDate
optional

End date and time of the training event

YYYY-MM-DDTHH:mm:ss.SSSZ

4.29. UserData

User data for create or update

Name Description Schema

address
required

User address

string

customAttributes
optional

User attributes. These custom attributes are exposed to external BI systems for data analysis purposes (e.g. age, sex, geography, employee role in company, academic degree etc.)

object

email
optional

User email

string

firstName
optional

User first name

string

identifier
required

The unique id of the model entity - defined by an external provider
Example : "u1"

string

isActive
optional

User status. Possible values: "true" or "false". Default: true
Example : true

boolean

lastName
optional

User last name

string

password
optional

User password

string

phone
optional

User phone number

string

possibleRoles
optional

User possible roles

< enum (SITE_ADMIN, LEARNER, INSTRUCTOR, EDITOR, PREVIEW, MANAGER, HR_MANAGER, SITE_TRAINING_MANAGER, EVALUATOR) > array

subAccountName
optional

Sub-account name

string

username
optional

Username
Example : "albanB"

string

4.30. UserIdentity

User identity data

Name Description Schema

currentUserIdentifier
required

Existing user identifier

string

newUserIdentifier
required

New user identifier to assign

string

4.31. UserInfo

User info of existing user

Name Description Schema

address
required

User address

string

created
required

User creation date

YYYY-MM-DDTHH:mm:ss.SSSZ

customAttributes
required

User attributes. These custom attributes are exposed to external BI systems for data analysis purposes (e.g. age, sex, geography, employee role in company, academic degree etc.)

object

email
required

User email

string

firstName
required

User first name

string

identifier
required
read-only

The unique id of the model entity - defined by an external provider

string

isActive
required

User status
Example : false

boolean

lastName
required

User last name

string

modified
required

User modification date

YYYY-MM-DDTHH:mm:ss.SSSZ

phone
required

Username

string

possibleRoles
required

User possible roles

< enum (SITE_ADMIN, LEARNER, INSTRUCTOR, EDITOR, PREVIEW, MANAGER, HR_MANAGER, SITE_TRAINING_MANAGER, EVALUATOR) > array

userSubAccountNames
required

Sub-account name(s) to which the user belongs

< string > array

username
required

User phone number

string

4.32. UserProfileData

User Profile data for update

Name Description Schema

identifier
required

The unique id of the model entity - defined by an external provider

string

name
required

User Profile name

string

4.33. UserProfileInfo

User Profile info

Name Description Schema

created
required

User Profile creation date

YYYY-MM-DDTHH:mm:ss.SSSZ

identifier
required

The unique id of the model entity - defined by an external provider

string

modified
required

User Profile modification date

YYYY-MM-DDTHH:mm:ss.SSSZ

name
required

User Profile name

string

4.34. requirementUpdate

Certificate requirements update data

Name Description Schema

certificateIdentifier
optional

certificateIdentifier

string

isRequired
optional

isRequired
Example : false

boolean

userIdentifier
optional

userIdentifier

string